package com.goldenwater.slaj.eutr.controller;

import java.util.List;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;
import com.goldenwater.common.annotation.Log;
import com.goldenwater.common.core.controller.BaseController;
import com.goldenwater.common.core.domain.AjaxResult;
import com.goldenwater.common.core.page.TableDataInfo;
import com.goldenwater.common.enums.BusinessType;
import com.goldenwater.common.utils.poi.ExcelUtil;
import com.goldenwater.slaj.eutr.domain.BisEutrCourRec;
import com.goldenwater.slaj.eutr.service.IBisEutrCourRecService;

@RestController
@RequestMapping("/eutr/courrec")
public class BisEutrCourRecController extends BaseController {
    @Autowired
    private IBisEutrCourRecService bisEutrCourRecService;

    @GetMapping("/list")
    public TableDataInfo list(BisEutrCourRec bisEutrCourRec) {
        startPage();
        List<BisEutrCourRec> list = bisEutrCourRecService.selectBisEutrCourRecList(bisEutrCourRec);
        return getDataTable(list);
    }

    @GetMapping("/{guid}")
    public AjaxResult getInfo(@PathVariable String guid) {
        return AjaxResult.success(bisEutrCourRecService.selectBisEutrCourRecByGuid(guid));
    }

    @PostMapping
    public AjaxResult add(@RequestBody BisEutrCourRec bisEutrCourRec) {
        return toAjax(bisEutrCourRecService.insertBisEutrCourRec(bisEutrCourRec));
    }

    @PutMapping
    public AjaxResult edit(@RequestBody BisEutrCourRec bisEutrCourRec) {
        return toAjax(bisEutrCourRecService.updateBisEutrCourRec(bisEutrCourRec));
    }

    @DeleteMapping("/{guids}")
    public AjaxResult remove(@PathVariable String[] guids) {
        return toAjax(bisEutrCourRecService.deleteBisEutrCourRecByGuids(guids));
    }

    @Log(title = "培训课程参与记录管理", businessType = BusinessType.EXPORT)
    @PreAuthorize("@ss.hasPermi('eutr:courrec:export')")
    @PostMapping("/export")
    public void export(HttpServletResponse response, BisEutrCourRec bisEutrCourRec) {
        List<BisEutrCourRec> list = bisEutrCourRecService.selectBisEutrCourRecList(bisEutrCourRec);
        ExcelUtil<BisEutrCourRec> util = new ExcelUtil<BisEutrCourRec>(BisEutrCourRec.class);
        util.exportExcel(response, list, "培训课程参与记录数据");
    }
}
